Introduction
---------------
Many sites use an _edit domain_ (e.g. edit.example.com) - a domain where authors do their work, and no end users are allowed access. On the non -edit domain (e.g. www.example.com), logins and personalization are supported by authoring is not.This segregation can improve site security.

This module gently overrides UserRolesAccessPolicy from Drupal core. Roles are dynamically removed from users when using a non-edit domain. See [Access Policy API](https://www.drupal.org/node/3385551).

Configuration
---------------
Use a settings override to name the roles which are permitted on a non-edit domain. The default is:

```
$settings['domain_perm_roles_exempt'] = ['anonymous', 'authenticated'];
```

Customization
-----------------------
If you require alternate logic for isEditDomain() or anything else, it is recommended to use this module as a model for your own class that similarly overrides `Drupal\Core\Session\UserRolesAccessPolicy`. There isn't any benefit to enabling this module in that case.

Development of this module
-----------------
1. DDEV configuration is available.
   1. https://domain-perm2.ddev.site is available after `ddev start`.
   2. A https://domain-perm2-content.ddev.site additional domain is available as an edit domain.
2. The DDEV add-on https://github.com/ddev/ddev-drupal-contrib is available. Setup steps:
   - `git clone git@git.drupal.org:project/domain_perm.git && cd domain_perm`
   - `ddev start`
   - `ddev poser`
   - `ddev symlink-project`
   - `ddev drush si demo_umami -y`
   - `ddev drush uli --uid=2`
